Index: s390-tools-sles11/libvtoc/vtoc.c
===================================================================
--- s390-tools-sles11.orig/libvtoc/vtoc.c
+++ s390-tools-sles11/libvtoc/vtoc.c
@@ -326,7 +326,7 @@ void vtoc_volume_label_init (volume_labe
 {
 	sprintf(buffer, "%84s", " ");
 	vtoc_ebcdic_enc(buffer, buffer, 84);	
-	strncpy(vlabel->volkey, buffer, 84);
+	memcpy(vlabel, buffer, 84);
 }
 
 
Index: s390-tools-sles11/ipl_tools/ccw.c
===================================================================
--- s390-tools-sles11.orig/ipl_tools/ccw.c
+++ s390-tools-sles11/ipl_tools/ccw.c
@@ -51,33 +51,22 @@ int isccwdev(const char *devno)
 	return -1;
 }
 
-/*
- * return the device number for a device
- * dasda can be found in /sys/block/dasda/uevent or in a
- * symbolic link in the same directory. the first file only
- * contains the relevant information if we run on a kernel with
- * has the following kernel option enabled:
- * CONFIG_SYSFS_DEPRECATED
- *
- * This does not work when booting from tape
- */
-int get_ccw_devno(char *device, char *devno)
+
+int get_ccw_devno_old_sysfs(char *device, char *devno)
 {
 	FILE *filp;
 	int len, errorpath, rc;
 	char path1[4096];
-	char path2[4096];
 	char buf[4096];
 	char *match, *s1, *s2;
-	size_t linksize;
 
 	errorpath = 1;
+	rc = 0;
 	sprintf(path1, "/sys/block/%s/uevent", device);
 	filp = fopen(path1, "r");
 	if (!filp) {
-		errorpath = 1;
 		rc = -1;
-		goto out;
+		return rc;
 	}
 	/*
 	 * the uevent file contains an entry like this:
@@ -91,49 +80,72 @@ int get_ccw_devno(char *device, char *de
 	s1 =  strchr(buf, '/');
 	s2 =  strrchr(buf, '/');
 	len = s2-s1;
-	if (s1 == NULL || s2 == NULL || len <= 0) {
+	strncpy(devno, s2 + 1, sizeof(devno));
+	devno[len] = '\0';
+	fclose(filp);
+	return 0;
+}
+
+int get_ccw_devno_new_sysfs(char *device, char *devno)
+{
+	int len, errorpath, rc;
+	char path2[4096];
+	char buf[4096];
+	char *s1, *s2;
+	ssize_t linksize;
+
+	errorpath = 1;
+	s1 = NULL;
+	s2 = NULL;
+	len = 0;
+	sprintf(path2, "/sys/block/%s/device", device);
+	linksize = readlink(path2, buf, sizeof(buf)-1);
+	if (linksize == -1) {
+		errorpath = 2;
+		rc = -1;
+		return rc;
+	} else {
 		/*
-		 * now we try to find the information in the second file
+		 * the output has the following format:
+		 *  ../../../0.0.4e13
 		 */
-		sprintf(path2, "/sys/block/%s/device", device);
-		linksize = readlink(path2, buf, sizeof(buf)-1);
-		if (linksize == -1) {
-			errorpath = 2;
+		s1 = strchr(buf, '/');
+		s2 = strrchr(buf, '/');
+		len = s2 - s1 + 2;
+		if (s1 == NULL || s2 == NULL || len <= 0) {
 			rc = -1;
-			goto out;
-		} else {
-			/*
-			 * the output has the following format:
-			 *  ../../../0.0.4e13
-			 */
-			s1 =  strchr(buf, '/');
-			s2 =  strrchr(buf, '/');
-			len = s2-s1+2;
-			if (s1 == NULL || s2 == NULL || len <= 0) {
-				rc = -1;
-				goto out;
-			}
-			strncpy(devno, s2+1, sizeof(devno));
-			devno[len] = '\0';
-			return 0;
+			fprintf(stderr, "%s: Can not open %s: %s\n",
+					 name, path2, strerror(errno));
+			return rc;
 		}
-
 	}
-	strncpy(devno, s2+1, sizeof(devno));
+	strncpy(devno, s2 + 1, sizeof(devno));
 	devno[len] = '\0';
-	fclose(filp);
 	return 0;
-out:
-	if (errorpath == 1 && rc == -1) {
-		 fprintf(stderr, "%s: Can not open %s: %s\n", name,
-			path1, strerror(errno));
-	}
-	if (errorpath == 2 && rc == -1) {
-		 fprintf(stderr, "%s: Can not open %s: %s\n",
-				 name, path2, strerror(errno));
+}
+
+/*
+ * return the device number for a device
+ * dasda can be found in /sys/block/dasda/uevent or in a
+ * symbolic link in the same directory. the first file only
+ * contains the relevant information if we run on a kernel with
+ * has the following kernel option enabled:
+ * CONFIG_SYSFS_DEPRECATED
+ *
+ * This does not work when booting from tape
+ */
+int get_ccw_devno(char *device, char *devno)
+{
+    if (get_ccw_devno_old_sysfs(device, devno) != 0) {
+	if (get_ccw_devno_new_sysfs(device, devno) != 0) {
+		fprintf(stderr, "%s: Failed to lookup the device number\n",
+			name);
+		return -1;
 	}
-	return rc;
+    }
+    return 0;
 }
+
 int get_ccw_dev(char *partition, char *device)
 {
 	char   *stop;
Index: s390-tools-sles11/ipl_tools/chreipl.h
===================================================================
--- s390-tools-sles11.orig/ipl_tools/chreipl.h
+++ s390-tools-sles11/ipl_tools/chreipl.h
@@ -14,9 +14,6 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  */
 
-#define ZSA_VERSION "1.0"
-
-
 extern int use_ccw;	/* ccw or fcp */
 extern int verbose;
 extern int bootprog;
Index: s390-tools-sles11/ipl_tools/getopt.c
===================================================================
--- s390-tools-sles11.orig/ipl_tools/getopt.c
+++ s390-tools-sles11/ipl_tools/getopt.c
@@ -29,27 +29,27 @@
 #include "zt_common.h"
 #include "chreipl.h"
 
-const char *version = ZSA_VERSION;
-
 const char *const usage_ripl =
 "Usage: %s TYPE ARGS [OPTIONS]\n"
 "\n"
-"TYPE specifies the IPL device type:\n"
+" chreipl ccw -d <DEVICE> [-L <LPARM>]\n"
+" chreipl fcp -d <DEVICE> -l <LUN> -w <WWPN> [-b <BPROG>]\n"
+" chreipl node <NODE>\n"
+" chreipl [-h] [-v]\n"
+"\n"
+"The types specify the IPL device type:\n"
 "  ccw      IPL from CCW device (e.g. DASD)\n"
 "  fcp      IPL from FCP device (e.g. SCSI)\n"
 "  node     IPL from device specified by device node (e.g. /dev/dasda)\n"
 "\n"
-"ARGS specifies IPL arguments:\n"
-"  -d, --device DEVICE Device number of the IPL device (ccw) or adapter (fcp)\n"
-"  -l  --lun LUN       Logical unit number of the IPL device (fcp)\n"
-"  -w  --wwpn WWPN     World Wide Port Name of the IPL device (fcp)\n"
-"  NODE                Device node of the IPL device, e.g. /dev/dasda (node)\n"
-"\n"
 "OPTIONS:\n"
-"  -b, --bootprog PARM   bootprog specification (fcp only)\n"
-"  -L, --loadparm PARM   Loadparm specification (dasd only)\n"
-"  -h, --help            Print this help, then exit\n"
-"  -v, --version         Print version information, then exit\n";
+"  -d, --device <DEVICE>  Number of the IPL device (ccw) or adapter (fcp)\n"
+"  -l  --lun <LUN>        Logical unit number of the IPL device\n"
+"  -w  --wwpn <WWPN>>      World Wide Port Name of the IPL device\n"
+"  -b, --bootprog <BPROG> Bootprog specification\n"
+"  -L, --loadparm <PARM> Loadparm specification\n"
+"  -h, --help             Print this help, then exit\n"
+"  -v, --version          Print version information, then exit\n";
 
 const char *const usage_sa =
 "Usage: %s TRIGGER ACTION [COMMAND] [OPTIONS]\n"
@@ -57,10 +57,11 @@ const char *const usage_sa =
 "Change action to be performed after shutdown.\n"
 "\n"
 "TRIGGER specifies when the action is performed:\n"
-"  halt      System has been shut down (e.g. shutdown -h)\n"
-"  poff      System has been shut down for power off (e.g. shutdown -p)\n"
+"  halt      System has been shut down (e.g. shutdown -h -H now)\n"
+"  poff      System has been shut down for power off (e.g. shutdown -h -P now)\n"
 "  reboot    System has been shut down for reboot (e.g. shutdown -r)\n"
 "  panic     System has been shut down after a kernel panic\n"
+"  Note: Depending on the distribution, \"halt\" might be mapped to \"poff\".\n"
 "\n"
 "ACTION specifies the action to be performed:\n"
 "  ipl       IPL with previous settings\n"
@@ -120,9 +121,9 @@ void print_usage_ripl(char program_name[
 
 void print_version()
 {
-	printf("%s: Linux on System z shutdown actions version  %s (%s)\n",
-		name, RELEASE_STRING, version);
-	printf("Copyright IBM Corp. 2008.\n");
+	printf("%s: Linux on System z shutdown actions version %s\n",
+		name, RELEASE_STRING);
+	printf("Copyright IBM Corp. 2008\n");
 	exit(0);
 }
 
@@ -263,7 +264,7 @@ static void check_blank(char *optarg1, c
 	 * this prevents e.g. -d4711 and enforces the
 	 * user to specify -d 4711
 	 */
-	if (optarg1 != optarg2) {
+	if (strcmp(optarg1, optarg2) != 0) {
 		fprintf(stderr, "%s: Unrecognized option: %s\n", name, optarg);
 		exit(1);
 	}
@@ -324,7 +325,7 @@ static void parse_node_args(char *nargv[
 	}
 
 	/* a valid entry has to start with /dev/ */
-	// XXX no valid assumption to check only strings...
+	/* XXX no valid assumption to check only strings... */
 	if (strlen(nargv[0]) < 8) {
 		fprintf(stderr, "%s: Invalid device node specified\n", name);
 		exit(1);
@@ -506,7 +507,6 @@ void parse_options(int argc, char **argv
 		fprintf(stderr, "%s: No valid action specified\n", name);
 		exit(1);
 	}
-		
 	/*
 	 * optind is a index which points to the first unrecognised
 	 * command line argument
@@ -575,11 +575,6 @@ void parse_shutdown_options(int argc, ch
 			printf("Try '%s' --help' for more information.\n",
 				argv[0]);
 			break;
-		case -1:
-			/*
-			 * we also run in this case if no argument was specified
-			 */
-			break;
 		default:
 			print_usage_sa(argv[0]);
 		}
@@ -647,6 +642,8 @@ void parse_shutdown_options(int argc, ch
 			rc = strwrt(argv[2],
 				"/sys/firmware/shutdown_actions/on_panic");
 			if (action == 4 && rc == 0) {
+				/*rc = ustrwrt(argv[3],
+					"/sys/firmware/vmcmd/on_reboot"); */
 				rc = ustrwrt(argv[3],
 					"/sys/firmware/vmcmd/on_panic");
 			}
Index: s390-tools-sles11/ipl_tools/ipl.c
===================================================================
--- s390-tools-sles11.orig/ipl_tools/ipl.c
+++ s390-tools-sles11/ipl_tools/ipl.c
@@ -124,7 +124,7 @@ void print_ipl_settings(void)
 	rc = strrd(devno, "/sys/firmware/ipl/device");
 	if (rc != 0)
 		exit(1) /* the error msg comes from get_ipl_device */;
-	if (devno != NULL)
+	if (strlen(devno) > 0)
 		printf("Device:        %s\n", devno);
 	if (type == 1) {
 		rc = get_ipl_loadparam();
@@ -136,10 +136,10 @@ void print_ipl_settings(void)
 	if (type == 0) {
 		/* these settings are only available for fcp */
 		rc = strrd(wwpn, "/sys/firmware/reipl/fcp/wwpn");
-		if (rc != -1 && wwpn != NULL)
+		if (rc != -1 && strlen(wwpn) > 0)
 			printf("WWPN:          %s\n", wwpn);
 		rc = strrd(lun, "/sys/firmware/ipl/lun");
-		if (rc != -1 && lun != NULL)
+		if (rc != -1 && strlen(lun) > 0)
 			printf("LUN:           %s\n", lun);
 		rc = strrd(bootprog, "/sys/firmware/reipl/fcp/bootprog");
 		if (rc != -1 && strlen(bootprog) > 0)
Index: s390-tools-sles11/ipl_tools/main.c
===================================================================
--- s390-tools-sles11.orig/ipl_tools/main.c
+++ s390-tools-sles11/ipl_tools/main.c
@@ -80,23 +80,23 @@ int lsreipl(int argc, char *argv[])
 		rc = strrd(lba, "/sys/firmware/reipl/fcp/br_lba");
 		if (rc != 0)
 			exit(1);
-	if (wwpn != NULL)
-		printf("WWPN:        %s\n", wwpn);
-	if (lun != NULL)
-		printf("LUN:         %s\n", lun);
-	if (devno != NULL)
-		printf("Device:      %s\n", devno);
-	if (bootprog != NULL)
-		printf("bootprog:    %s\n", bootprog);
-	if (lba != NULL)
-		printf("br_lba:      %s\n", lba);
+		if (strlen(wwpn) > 0)
+			printf("WWPN:        %s\n", wwpn);
+		if (strlen(lun) > 0)
+			printf("LUN:         %s\n", lun);
+		if (strlen(devno) > 0)
+			printf("Device:      %s\n", devno);
+		if (strlen(bootprog) > 0)
+			printf("bootprog:    %s\n", bootprog);
+		if (strlen(lba) > 0)
+			printf("br_lba:      %s\n", lba);
 	}
 	if (rc == 1) {
 		printf("Re-IPL type:   ccw\n");
 		rc = strrd(devno, "/sys/firmware/reipl/ccw/device");
 		if (rc != 0)
 			exit(1);
-		if (devno != NULL && strlen(devno) > 0)
+		if (strlen(devno) > 0)
 			printf("Device:        %s\n", devno);
 		/*
 		 * check if we can read the load parameter (Loadparm)
Index: s390-tools-sles11/README
===================================================================
--- s390-tools-sles11.orig/README
+++ s390-tools-sles11/README
@@ -6,7 +6,7 @@ s390-tools (1.8.0)
    The package contains:
 
    * dasdfmt:
-     Low-level format ECKD DASDs with the classical linux disk layout or the new
+     Low-level format ECKD DASDs with the classical Linux disk layout or the new
      z/OS compatible disk layout.
 
    * fdasd:
@@ -96,20 +96,20 @@ s390-tools (1.8.0)
      Set of scripts to configure and list status information of Linux for
      zSeries IO devices.
      - chccwdev: Modify generic attributes of channel attached devices.
-     - lscss:    List channel subsystem devices.
-     - lsdasd:   List channel attached direct access storage devices (DASD).
-     - lsqeth:   List all qeth-based network devices with their corresponding
-                 settings.
-     - lstape:   List tape devices, both channel and FCP attached.
-     - lszfcp:   Shows information contained in sysfs about zfcp adapters, ports
-                 and units that are online.
-     - lschp:    List information about available channel-paths.
-     - chchp:    Modify channel-path state.
-     - lsluns:   List available SCSI LUNs depending on adapter or port.
-     - lszcrypt: Show Information about zcrypt devices and configuration.
-     - chzcrypt: Modify zcrypt configuration.
-     - znetconf: List and configure network devices for System z network
-                 adapters.
+     - lscss:      List channel subsystem devices.
+     - lsdasd:     List channel attached direct access storage devices (DASD).
+     - lsqeth:     List all qeth-based network devices with their corresponding
+                   settings.
+     - lstape:     List tape devices, both channel and FCP attached.
+     - lszfcp:     Shows information contained in sysfs about zfcp adapters,
+                   ports and units that are online.
+     - lschp:      List information about available channel-paths.
+     - chchp:      Modify channel-path state.
+     - lsluns:     List available SCSI LUNs depending on adapter or port.
+     - lszcrypt:   Show Information about zcrypt devices and configuration.
+     - chzcrypt:   Modify zcrypt configuration.
+     - znetconf:   List and configure network devices for System z network
+                   adapters.
 
    * dumpconf:
      Allows to configure the dump device used for system dump in case a kernel
@@ -132,7 +132,7 @@ s390-tools (1.8.0)
      memory can be increased or decreased exploiting the CMM1 feature.
 
    * ipl_tools:
-     Tools set to configure and list reipl and shutdown actions.
+     Tool set to configure and list reipl and shutdown actions.
      - lsreipl: List information of reipl device.
      - chreipl: Change reipl device settings.
      - lsshut:  List actions which will be done in case of halt, poff, reboot
@@ -141,18 +141,17 @@ s390-tools (1.8.0)
                 reboot or panic.
 
    * ziomon tools:
-     Tool set to collect data for zfcp performance analysis and generate
-     reports.
+     Tool set to collect data for zfcp performance analysis and report.
 
    * iucvterm:
      z/VM IUCV terminal applications.
 
-     A set of applications to provide terminal access over the z/VM Inter-User
+     A set of applications to provide terminal access via the z/VM Inter-User
      Communication Vehicle (IUCV). The terminal access does not require an
-     active IP network connection between two Linux guest operating systems.
+     active TCP/IP connection between two Linux guest operating systems.
 
-     - iucvconn:  Start terminal connection over z/VM IUCV.
-     - iucvtty:   Allow remote logins over z/VM IUCV.
+     - iucvconn:  Application to establish a terminal connection via z/VM IUCV.
+     - iucvtty:   Application to provide terminal access via z/VM IUCV.
      - ts-shell:  Terminal server shell to authorize and control IUCV terminal
                   connections for individual Linux users.
 
@@ -160,7 +159,6 @@ s390-tools (1.8.0)
 For more information refer to the following publications:
    * "Device Drivers, Features, and Commands" chapter "Useful Linux commands"
    * "Using the dump tools"
-   * "How to Set up a Terminal Server Environment"
 
 Dependencies:
 =============
@@ -278,7 +276,7 @@ Release History:
 
     - dumpconf: Add VMCMD support
          The dumpconf init script now exploits the new "shutdown actions
-         interface" introduced with vanilla linux kernel 2.6.25. Up to
+         interface" introduced with vanilla Linux kernel 2.6.25. Up to
          five VM commands can be specified to be triggered in case of
          a kernel panic.
 
@@ -412,7 +410,7 @@ Release History:
 
      Added new features for existing tools:
      - zipl: multi boot, IPL from tape, custom dump size limit
-     - dbginfo.sh: adaptions for linux 2.6
+     - dbginfo.sh: adaptions for Linux 2.6
 
 1.2.2: Added new tool:
      - ip_watcher/start_hsnc
Index: s390-tools-sles11/etc/init.d/cpuplugd
===================================================================
--- s390-tools-sles11.orig/etc/init.d/cpuplugd
+++ s390-tools-sles11/etc/init.d/cpuplugd
@@ -1,8 +1,10 @@
 #!/bin/bash
 ### BEGIN INIT INFO
 # Provides: cpuplugd
-# Required-Start: $remote_fs
-# Required-Stop: $remote_fs
+# Required-Start: $local_fs $remote_fs
+# Required-Stop: $local_fs $remote_fs
+# Should-Start: 
+# Should-Stop: 
 # Default-Start: 2 3 4 5
 # Default-Stop: 0 1 6
 # Short-Description: Start the cpu hotplug daemon for Linux on System z
@@ -26,7 +28,13 @@ start()
 {
 	if [ ! -f $RUN_PID_FILE ]; then
 		echo -n $"Starting $DAEMON:"
-		$DAEMON_PATH $OPTIONS && log_success_msg || log_failure_msg
+		$DAEMON_PATH $OPTIONS
+		if [ $? == "0" ]; then
+			touch /var/lock/subsys/cpuplugd
+			log_success_msg
+		else
+			log_failure_msg
+		fi
 		echo
 	else
 		echo "$DAEMON (pid $(cat $RUN_PID_FILE)) is already running..."
@@ -41,6 +49,7 @@ stop()
 		killproc $DAEMON_PATH -TERM
 		log_success_msg
 		rm -f $RUN_PID_FILE
+		rm -f /var/lock/subsys/cpuplugd
 	else
 		log_failure_msg
 	fi
Index: s390-tools-sles11/etc/init.d/dumpconf
===================================================================
--- s390-tools-sles11.orig/etc/init.d/dumpconf
+++ s390-tools-sles11/etc/init.d/dumpconf
@@ -3,14 +3,16 @@
 # Provides: dumpconf
 # Required-Start: $local_fs
 # Required-Stop: $local_fs
-# Default-Start:  1 2 3 4 5
-# Default-Stop: 0 6
+# Should-Start:
+# Should-Stop:
+# Default-Start: 0 1 2 3 4 5 6
+# Default-Stop:
 # Short-Description: Configure s390 dump feature
 # Description: Configures the s390 dump feature. It uses the configuration file
 #              /etc/sysconfig/dumpconf
 ### END INIT INFO
 
-# chkconfig: 12345 01 99
+# chkconfig: 0123456 01 99
 
 DUMP_CONFIG_FILE=/etc/sysconfig/dumpconf
 ERRMSG="Check $DUMP_CONFIG_FILE!"
Index: s390-tools-sles11/etc/init.d/mon_statd
===================================================================
--- s390-tools-sles11.orig/etc/init.d/mon_statd
+++ s390-tools-sles11/etc/init.d/mon_statd
@@ -1,8 +1,10 @@
 #!/bin/bash
 ### BEGIN INIT INFO
 # Provides: mon_statd
-# Required-Start: $remote_fs
-# Required-Stop: $remote_fs
+# Required-Start: $local_fs $remote_fs
+# Required-Stop: $local_fs $remote_fs
+# Should-Start: 
+# Should-Stop: 
 # Default-Start: 2 3 4 5
 # Default-Stop: 0 1 6
 # Short-Description: Configure the mon_fsstatd and mon_procd daemons.
@@ -45,16 +47,26 @@ start()
 
 	if [ ! -f $FSSTATD_PID_FILE -a "$FSSTAT" = "yes" ]; then
 		echo -n $"Starting $FSSTATD:"
-		$FSSTATD_PATH -i $FSSTAT_INTERVAL && log_success_msg ||
-						     log_failure_msg
+		$FSSTATD_PATH -i $FSSTAT_INTERVAL
+		if [ $? == 0 ]; then
+			touch /var/lock/subsys/mon_statd
+			log_success_msg
+		else
+			log_failure_msg
+		fi
 	elif [ "$FSSTAT" = "yes" ]; then
 		echo "$FSSTATD (pid $(cat $FSSTATD_PID_FILE)) is already running..."
 	fi
 
 	if [ ! -f $PROCD_PID_FILE -a "$PROC" = "yes" ]; then
 		echo -n $"Starting $PROCD:"
-		$PROCD_PATH -i $PROC_INTERVAL && log_success_msg ||
-						 log_failure_msg
+		$PROCD_PATH -i $PROC_INTERVAL
+		if [ $? == 0 ]; then
+			touch /var/lock/subsys/mon_statd
+			log_success_msg
+		else
+			log_failure_msg
+		fi
 	elif [ "$PROC" = "yes" ]; then
 		echo "$PROCD (pid $(cat $PROCD_PID_FILE)) is already running..."
 	fi
@@ -80,6 +92,7 @@ stop()
 	else
 		log_failure_msg
 	fi
+	rm -f /var/lock/subsys/mon_statd
 	echo
 }
 
Index: s390-tools-sles11/ip_watcher/Makefile
===================================================================
--- s390-tools-sles11.orig/ip_watcher/Makefile
+++ s390-tools-sles11/ip_watcher/Makefile
@@ -1,6 +1,7 @@
 # Include common definitions
 include ../common.mak
 
+CFLAGS += -I../include
 all: xcec-bridge
 
 clean:
Index: s390-tools-sles11/ip_watcher/xcec-bridge.c
===================================================================
--- s390-tools-sles11.orig/ip_watcher/xcec-bridge.c
+++ s390-tools-sles11/ip_watcher/xcec-bridge.c
@@ -32,6 +32,7 @@
 #include <string.h>
 #include <dirent.h>
 #include <sys/stat.h>
+#include "zt_common.h"
 
 /* a signal causes the interfaces to be re-checked */
 
@@ -575,7 +576,7 @@ void process_packet(struct int_sock *i_s
 	}
 }
 
-void action_handler(int s)
+void action_handler(int UNUSED(s))
 {
 	update_interface_trigger=1;
 	syslog(LOG_DEBUG,"signal caught");
Index: s390-tools-sles11/zconf/chccwdev
===================================================================
--- s390-tools-sles11.orig/zconf/chccwdev
+++ s390-tools-sles11/zconf/chccwdev
@@ -1,6 +1,6 @@
 #!/bin/sh
 #==============================================================================
-# Copyright IBM Corp. 2003, 2006.
+# Copyright IBM Corp. 2003, 2009.
 #
 # chccwdev
 #
@@ -8,6 +8,7 @@
 # only support for kernels with sysfs support and the only attribute is online.
 #
 # Author(s): S. Bader <shbader@de.ibm.com>
+#            Sebastian Ott <sebott@linux.vnet.ibm.com>
 #
 # This file is part of s390-tools
 #
@@ -26,6 +27,7 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 #==============================================================================
 CMD=$(basename $0)
+MAX_RETRIES=5
 
 if [ "$(cat /proc/filesystems|grep sysfs)" = "" ]; then
 	echo "ERROR: $CMD requires sysfs support!" >&2
@@ -49,7 +51,7 @@ function PrintUsage() {
 		 		driver supports this.
 		  	-d|--offline
 		  		Tries to set the given device offline.
-		 	--version
+		 	-v|--version
 		 		Show tools and command version.
 
 		<devices>
@@ -59,10 +61,9 @@ function PrintUsage() {
 
 function PrintVersion()
 {
-	local TVER="1.18"
 	cat <<-EOD
-	$CMD: version %S390_TOOLS_VERSION% ($TVER).
-	Copyright IBM Corp. 2003, 2006.
+	$CMD: version %S390_TOOLS_VERSION%
+	Copyright IBM Corp. 2003, 2009
 	EOD
 }
 
@@ -138,7 +139,7 @@ while [ $# -gt 0 ]; do
 				ONLINE=0
 				ACTIONSET=true
 				;;
-		--version)
+		-v|--version)
 				PrintVersion
 				exit 0
 				;;
@@ -244,14 +245,23 @@ BUSIDLIST=$(
 			print "Invalid range order" >err
 			return -1
 		}
+		found = 0
 		for (i = from; i <= to; i++) {
 			# Expand ranges only to valid entries.
 			busid = parts1[1] "." parts1[2] "." dec2hex(i)
 			filen = SYSFSBASE busid "/devtype"
-			if ((getline x <filen) > 0)
+			if ((getline x <filen) > 0) {
+				found = 1
 				print busid
+			}
 			close(filen)
 		}
+		if (!found) {
+			print "No Device in range (" parts1[1] "." parts1[2] \
+				"." parts1[3] "-" parts2[1] "." parts2[2]    \
+				"." parts2[3] ") found" >err
+			return -1
+		}
 	}
 	BEGIN{
 		SYSFSBASE = "'$SYSFSDIR'/bus/ccw/devices/"
@@ -296,13 +306,14 @@ if ! $ACTIONSET; then
 fi
 
 function IsOnline() {
-	if [ ! -f "$1/online" ]; then
+	local ONLINE=$(cat $1/online 2>/dev/null)
+	if [ -z $ONLINE ]; then
 		if [ $2 -eq 0 ]; then
 			return 0
 		fi
 		return 1
 	fi
-	if [ $(cat $1/online) -eq $2 ]; then
+	if [ $ONLINE -eq $2 ]; then
 		return 0
 	fi
 	return 1
@@ -354,7 +365,7 @@ SAVEDATTRS=("${ATTRVAL[@]}")
 for BUSID in $BUSIDLIST; do
 	SYSPATH=$SYSFSDIR/bus/ccw/devices/$BUSID
 	if [ ! -r $SYSPATH ]; then
-		echo "$BUSID is not a channel device"
+		echo "Device $BUSID not found"
 		exit 1
 	fi
 
@@ -377,7 +388,7 @@ for BUSID in $BUSIDLIST; do
 				echo "WARNING: Device[$BUSID] is already " \
 					"online" >&2
 			else
-				echo "Device already is offline" >&2
+				echo "Device is already offline" >&2
 			fi
 		else
 			if [ "$ONLINE" -eq 1 ]; then
@@ -390,14 +401,15 @@ for BUSID in $BUSIDLIST; do
 			else
 				echo $ONLINE >$SYSPATH/online 2>/dev/null
 			fi
-
-			if ! IsOnline $SYSPATH $ONLINE; then
-				sleep 1
-				if ! IsOnline $SYSPATH $ONLINE; then
+			RETRIES=0
+			while ! IsOnline $SYSPATH $ONLINE; do
+				if [ $RETRIES -eq $MAX_RETRIES ]; then
 					echo "Failed" >&2
 					exit 1
 				fi
-			fi
+				sleep 0.5
+				let "RETRIES++"
+			done
 		fi
 	fi
 
Index: s390-tools-sles11/zconf/chchp
===================================================================
--- s390-tools-sles11.orig/zconf/chchp
+++ s390-tools-sles11/zconf/chchp
@@ -1,6 +1,6 @@
 #!/bin/bash
 #==============================================================================
-# Copyright IBM Corp. 2007
+# Copyright IBM Corp. 2007, 2009
 #
 # chchp
 #
@@ -53,8 +53,8 @@ EOF
 function print_version()
 {
 	cat <<EOF
-${TOOLNAME}: version ${VERSION}.
-Copyright IBM Corp. 2007
+${TOOLNAME}: version ${VERSION}
+Copyright IBM Corp. 2007, 2009
 EOF
 }
 
@@ -182,6 +182,12 @@ function check_and_set_value()
 			exit 1
 		fi
 	fi
+	if [ \( "$COMMAND" == "vary" -o "$COMMAND" == "configure" \) -a \
+	     "$1" != "0" -a "$1" != "1" ] ; then
+		echo "$TOOLNAME: Invalid value for --${COMMAND} (only 0 or 1" \
+		    "allowed)" >&2
+		exit 1
+	fi
 	VALUE=$1
 }
 
Index: s390-tools-sles11/zconf/lscss
===================================================================
--- s390-tools-sles11.orig/zconf/lscss
+++ s390-tools-sles11/zconf/lscss
@@ -1,6 +1,6 @@
 #!/bin/bash
 #==============================================================================
-# Copyright IBM Corp. 2003,2008
+# Copyright IBM Corp. 2003,2009
 #
 # lscss
 #
@@ -54,7 +54,7 @@ function print_usage() {
 		 		identifiers.
 		 	--avail
 		 		Show availability attribute of IO devices.
-		 	--version
+		 	-v|--version
 		 		Show tools and command version.
 		 	-u|--uppercase
 		 		Print values using uppercase.
@@ -70,7 +70,7 @@ function print_usage() {
 function print_version()
 {
     VERSION="%S390_TOOLS_VERSION%"
-    echo -ne "$CMD: version $VERSION\nCopyright IBM Corp. 2003, 2008.\n"
+    echo -ne "$CMD: version $VERSION\nCopyright IBM Corp. 2003, 2009\n"
 }
 
 
@@ -81,6 +81,7 @@ IDFORMAT=[[:xdigit:]]*.[0-3].[[:xdigit:]
 
 unset SCH_IO SCH_CHSC SHOW_AVAIL UPPERCASE SHORTID DEVTYPES DEVRANGE RANGE
 shopt -s nocasematch
+shopt -s nullglob
 
 function check_id() #return 0 if $1 has a valid format
 {
@@ -165,7 +166,7 @@ while [ $# -gt 0 ]; do
 	    parse_devtypes $DEVTYPES
 	    shift
 	    ;;
-	--version)
+	-v|--version)
 	    print_version
 	    exit 0
 	    ;;
